SystemOrganization addCategory: #'PBE-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell methodsFor: 'initialization' stamp: 'yusenmanchego 9/21/2012 11:22'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff

! !

!LOCell methodsFor: 'accessing' stamp: 'yusenmanchego 9/21/2012 13:25'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!LOCell methodsFor: 'event handling' stamp: 'yusenmanchego 9/21/2012 13:08'!
mouseUp: anEvent
	mouseAction value
! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame methodsFor: 'as yet unclassified' stamp: 'davidmaldonado 9/22/2012 20:05'!
cellsPerSide
	"The number of cells along each side of the game"
	^#(10 20)
! !

!LOGame methodsFor: 'initialization' stamp: 'davidmaldonado 9/22/2012 20:04'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.	
	sampleCell := LOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*(n first )) @(height*(n second ))) + (2 * self borderWidth)).
	cells :=Matrix rows: (n first )  columns: (n second )  tabulate: [ :i :j | self newCellAt: i at: j ]
! !

!LOGame methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 9/21/2012 13:22'!
newCellAt: i at: j
	"Create a cell for position (i,j) and add it to my on?screen
		representation at the appropriate screen position. Answer the new cell"
	| c origin |
	c := LOCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^c

	
! !

!LOGame methodsFor: 'game logic
' stamp: 'yusenmanchego 9/24/2012 03:37'!
toggleNeighboursOfCellAt: i at: j
	"(i > 1) ifTrue: [ (cells at: i -1 at: j ) toggleState].
	(i < self cellsPerSide first ) ifTrue: [ (cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
	(j < self cellsPerSide second ) ifTrue: [ (cells at: i at: j + 1) toggleState]."
	
	(i > 1 and: j>1) ifTrue: [ (cells at: i -1 at: j-1 ) toggleState].
	(i < self cellsPerSide first and: j>1 ) ifTrue: [ (cells at: i + 1 at: j-1) toggleState].
	(i  >1 and: j<self cellsPerSide second) ifTrue: [ (cells at: i-1at: j + 1) toggleState].
	(i < self cellsPerSide first and: j < self cellsPerSide second ) ifTrue: [ (cells at: i+1 at: j + 1) toggleState].
	
! !
